> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/compute/zec/disk-snapshot/applyautosnapshotpolicy.md).

# ApplyAutoSnapshotPolicy

## 1. API Description

This API (ApplyAutoSnapshotPolicy) is used to attach a disk to the specified snapshot schedule.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

* <mark style="color:blue;">If the disk is already attached to this snapshot schedule, repeated operations will not return an error.</mark>
* <mark style="color:blue;">If the disk is already attached to another snapshot schedule, the error</mark> <mark style="color:blue;">`INVALID_DISK_AUTO_SNAPSHOT_POLICY_EXIST`</mark> <mark style="color:blue;">will be reported. And the operation will fail immediately.</mark>
* <mark style="color:blue;">If the attached disk is in unavailable state when the snapshot schedule is executed, the snapshot will not be created automatically.</mark>
* <mark style="color:blue;">A disk can only be attached to one snapshot schedule.</mark>
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name       | Required | Type            | Description                      |
| -------------------- | -------- | --------------- | -------------------------------- |
| autoSnapshotPolicyId | Yes      | String          | Snapshot schedule ID.            |
| diskIds              | Yes      | Array of String | ID list of disks to be attached. |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Attach disks to the snapshot schedule.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: ApplyAutoSnapshotPolicy
<Common Request Params>

Request：
{
  "autoSnapshotPolicyId": "<autoSnapshotPolicyId>",
  "diskIds": [
    "<diskId>"
  ]
}

Response：
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                                   | Description                                                     |
| ---------------- | -------------------------------------------- | --------------------------------------------------------------- |
| 404              | INVALID\_AUTO\_SNAPSHOT\_POLICY\_NOT\_FOUND  | The snapshot schedule does not exist.                           |
| 404              | INVALID\_AUTO\_SNAPSHOT\_ZONE\_MISMATCH      | Snapshot schedule and disk are in different availability zones. |
| 404              | INVALID\_DISK\_AUTO\_SNAPSHOT\_POLICY\_EXIST | The disk is attached to another snapshot schedule.              |
| 404              | INVALID\_DISK\_NOT\_FOUND                    | Disk does not exist.                                            |
